#pragma once

#include "GeometryNode.h"

class CircleNode : public GeometryNode
{
public:
    CircleNode(const Point& location, double radius);

    Type getType();

    double getRadius() const;

    SceneItem* getSceneItem(std::size_t idx) const override;
    std::size_t getNumSceneItems() const override;

    void setRadius(double radius);

    void update(SceneInfo* sceneInfo) override;
private:
    double mRadius{1};

    std::unique_ptr<SceneModel> mBackgroundItem;
    std::unique_ptr<SceneModel> mOutlineItem;
};
